// -*- C++ -*-
// $Id: Time_Date_Client_i.h,v 1.1 1999/04/30 00:57:13 schmidt Exp $

// ============================================================================
//
// = LIBRARY
//    TAO/examples/Simple/time-date
//
// = FILENAME
//    Time_Date_Client_i.h
//
// = DESCRIPTION
//    This class implements the interface calls for RMI.
//
// = AUTHOR
//   Douglas C. Schmidt <schmidt@cs.wustl.edu>
//    
// ============================================================================

#ifndef TIME_DATE_CLIENT_I_H
#define TIME_DATE_CLIENT_I_H

#include "../Simple_util.h"
#include "Time_DateC.h"

class Time_Date_Client_i
{
  // = TITLE
  //   Time_Date_Client interface subclass.
  //
  // = DESCRIPTION
  //   This class implements the interface between the interface
  //   objects and the client.
public:
  // = Initialization and termination methods.
  Time_Date_Client_i (void);
  // Constructor

  virtual ~Time_Date_Client_i (void);
  // Destructor

  virtual int run (char *, int, char *[]);
  // Execute the methods.

  virtual int parse_args (int argc, char *argv[]);
  // Parses the command line arguments

private:
  Client<Time_Date_Factory, Time_Date_Factory_var> client;
  // Instantiate the client object.
};

#endif /* TIME_CLIENT_I_H */
